{*************************************************************************
   Analog Interface Unit (AIU) - Test Program
   Version 1.0
   Written in Borland Pascal 7.0
   Current version last edited   : 28/5/95

   Copyright (c) 1994/95 David L. Jones
   Adavanced R&D Solutions
   12 Copeland Road
   Lethbridge Park NSW 2770
   Sydney, Australia.
***************************************************************************}

PROGRAM AIUTest;
USES AIU10, CRT;
VAR
   C,D : WORD;
   S,R,P:REAL;
   ERR : BOOLEAN;
CONST MSG1='Press any key to continue...';

BEGIN
   TEXTMODE(CO80);
   CLRSCR;
   TEXTCOLOR(LIGHTGRAY);
   WRITELN('Searching all ports for AIU...     ');
   WRITELN;
   DETECTAIU;

   IF PORTADDR=0 THEN BEGIN
      WRITELN('AIU not found. Exiting...');
      HALT(1);
   END;
   WRITELN('AIU detected at address ', PORTADDR);
   WRITELN(MSG1);
   REPEAT UNTIL KEYPRESSED;

{************************************************************************}
   CLRSCR;
   WRITELN('Testing data bus on AIU...');
   ERR:=FALSE;
   FOR C:=0 TO 255 DO BEGIN
      SETBYTE(C);
      D:=READBYTE;
      IF D<>C THEN ERR:=TRUE;
      IF KEYPRESSED THEN IF READKEY=#27 THEN HALT;
   END;
   WRITE('Data Port ');
   IF NOT ERR THEN WRITELN('PASSED') ELSE WRITELN('FAILED');
   WRITELN(MSG1);
   REPEAT UNTIL KEYPRESSED;


{************************************************************************}
   CLRSCR;
   TEXTCOLOR(LIGHTGRAY);
   WRITELN('Testing LoopBack on AIU.');
   WRITELN('This requires connection of Input and Output.');
   WRITELN('  SETBYTE     READABS     ERROR');
   WRITELN('Press any key when ready...');
   WINDOW(1,4,80,25);
   ERR:=FALSE;
   S:=-2.5;
   SETRANGE(TRUE);

   FOR C:=0 TO 255 DO BEGIN
      SETVOLTAGE(S,TRUE);
      DELAY(50);
      R:=READVOLTAGE(TRUE);
      IF S>R THEN P:=S-R ELSE P:=R-S;
      IF P>0.02 THEN BEGIN
         ERR:=TRUE;
         TEXTCOLOR(LIGHTRED)
      END
         ELSE TEXTCOLOR(WHITE);
      WRITELN('  ', S:2:4, '      ', R:2:4,'      ',P:2:4);
      IF KEYPRESSED THEN IF READKEY=#27 THEN HALT;
      S:=S+(5/256);
   END;

   WRITELN;
   WRITELN(MSG1);
   REPEAT UNTIL KEYPRESSED;


{************************************************************************}
   WINDOW(1,1,80,25);
   CLRSCR;
   TEXTCOLOR(LIGHTGRAY);
   WRITELN('Testing LoopBack on AIU.');
   WRITELN('This requires connection of Input and Output.');
   WRITELN('  SETBYTE      READABS      ERROR');
   WRITELN('Press any key when ready...');
   WINDOW(1,4,80,25);
   ERR:=FALSE;
   S:=-1.25;
   SETRANGE(FALSE);

   FOR C:=0 TO 255 DO BEGIN
      SETVOLTAGE(S,FALSE);
      DELAY(50);
      R:=READVOLTAGE(FALSE);
      IF S>R THEN P:=S-R ELSE P:=R-S;
      IF P>0.04 THEN BEGIN
         ERR:=TRUE;
         TEXTCOLOR(LIGHTRED)
      END
         ELSE TEXTCOLOR(WHITE);
      WRITELN('  ', S:1:4, '      ', R:1:4,'      ',P:2:4);
      IF KEYPRESSED THEN IF READKEY=#27 THEN HALT;
      S:=S+(2.5/256);
   END;

   WRITELN;
   WRITELN(MSG1);
   REPEAT UNTIL KEYPRESSED;
   WINDOW(1,1,80,25);
   CLRSCR;
END.
